﻿
// functions for getting colorvalues from prefs
// https://community.adobe.com/t5/after-effects-discussions/reading-the-label-colors-from-preferences-file/m-p/11945764
function getLabelNamesFromPrefs() {
$.appEncoding = 'CP1252';

  var sectionName2 = "Label Preference Text Section 5";
  var prefFile2 = PREFType.PREF_Type_MACHINE_INDEPENDENT;
  var keyName2;
  var mypref2;
  var resArray2 = [];

  for(var i = 1; i <= 16; i++){
    keyName2 = "Label Text ID 2 # " + i.toString();
    mypref2 = app.preferences.getPrefAsString(sectionName2, keyName2, prefFile2);
    resArray2.push(mypref2);
    }
    return resArray2;
}
// conversion table
var table1252 = { "€":128, "‚":130, "ƒ":131, "„":132, "…":133, "†":134, "‡":135, "ˆ":136, "‰":137, "Š":138, "‹":139, "Œ":140, "Ž":142, "‘":145, "’":146, "“":147, "”":148, "•":149, "–":150, "—":151, "˜":152, "™":153, "š":154, "›":155, 
    "œ":156, "ž":158, "Ÿ":159, "¡":161, "¢":162, "£":163, "¤":164, "¥":165, "¦":166, "§":167, "¨":168, "©":169, "ª":170, "«":171, "¬":172, "�­":173, "®":174, "¯":175, "°":176, "±":177, "²":178, "³":179, "´":180, "µ":181, "¶":182, 
    "·":183, "¸":184, "¹":185, "º":186, "»":187, "¼":188, "½":189, "¾":190, "¿":191, "À":192, "Á":193, "Â":194, "Ã":195, "Ä":196, "Å":197, "Æ":198, "Ç":199, "È":200, "É":201, "Ê":202, "Ë":203, "Ì":204, "Í":205, "Î":206, "Ï":207, 
    "Ð":208, "Ñ":209, "Ò":210, "Ó":211, "Ô":212, "Õ":213, "Ö":214, "×":215, "Ø":216, "Ù":217, "Ú":218, "Û":219, "Ü":220, "Ý":221, "Þ":222, "ß":223, "à":224, "á":225, "â":226, "ã":227, "ä":228, "å":229, "æ":230, "ç":231, "è":232, 
    "é":233, "ê":234, "ë":235, "ì":236, "í":237, "î":238, "ï":239, "ð":240, "ñ":241, "ò":242, "ó":243, "ô":244, "õ":245, "ö":246, "÷":247, "ø":248, "ù":249, "ú":250, "û":251, "ü":252, "ý":253, "þ":254, "ÿ":255
};


// covert to RGBA
// adapted from this: https://community.adobe.com/t5/after-effects-discussions/reading-the-label-colors-from-preferences-file/m-p/11945764
function getLabelsFromPrefsToRGBA(){
  $.appEncoding = 'CP1252';

  var sectionName = "Label Preference Color Section 5";
  var prefFile = PREFType.PREF_Type_MACHINE_INDEPENDENT;
  var keyName;
  var mypref;
  var resArray = [];

  for(var i = 1; i <= 16; i++){
    keyName = "Label Color ID 2 # " + i.toString();
    mypref = app.preferences.getPrefAsString(sectionName, keyName, prefFile);

    var res = [];
    for(var j = 1; j < mypref.length; j++) {
            var charCode = mypref.charCodeAt(j);
            if(charCode > 254){
                charCode = table1252[mypref[j]]
            }
            var newCode = charCode/255;
            if(newCode.toString().length === 1){
                newCode = '0'+newCode;
            }
            // alert(mypref[i] +' is '+charCode)
                res.push(newCode);
            }
            resArray.push(res);
  }
    return resArray;
};


function colorDialog(){
    // get colors form prefs
    if(app.preferences.havePref("keyframe buttons", "keyframe button # 1") ){
        var currentcolor = app.preferences.getPrefAsFloat("keyframe buttons", "keyframe button # 1"); var nopref = 0;
        }else{var currentcolor = 0; var nopref = 1;}
    if(app.preferences.havePref("keyframe buttons", "keyframe button # 2") ){
        var currentcolora = app.preferences.getPrefAsFloat("keyframe buttons", "keyframe button # 2"); var noprefa = 0;
        }else{var currentcolora = 0; var noprefa = 1;}
    if(app.preferences.havePref("keyframe buttons", "keyframe button # 3") ){
        var currentcolorb = app.preferences.getPrefAsFloat("keyframe buttons", "keyframe button # 3"); var noprefb = 0;
        }else{var currentcolorb = 0; var noprefb = 1;}
    if(app.preferences.havePref("keyframe buttons", "keyframe button # 4") ){
        var currentcolorc = app.preferences.getPrefAsFloat("keyframe buttons", "keyframe button # 4"); var noprefc = 0;
    }else{var currentcolorc = 0; var noprefc = 1;}
    
    var blocksize = [15,15];    var rowsize = [70,15];      var radiosize = [15,15];
    var radioalign = ["center","top"];
    
                // DIALOG
                // ======
                var dialog = new Window("dialog"); 
                    dialog.text = "Color Buttons Selection Dialog"; 
                    dialog.orientation = "column"; 
                    dialog.alignChildren = ["left","top"]; 
                    dialog.spacing = 8; 
                    dialog.margins = 8; 
                
                var toptext = dialog.add("group", undefined, {name: "group1"}); 
                    toptext.orientation = "row"; 
                    toptext.alignChildren = ["left","center"]; 
                    toptext.spacing = 4; 
                    toptext.margins = 4; 
                var statictext1 = toptext.add("statictext", undefined, undefined, {name: "statictext1"}); 
                    statictext1.text = "Select colors to set with your keyframe color buttons ";
                 // colors
                 // ======
                var topcolor1 = toptext.add("group", undefined, {name: "color1"}); topcolor1.orientation = "row"; topcolor1.alignChildren = ["center","center"]; topcolor1.size = blocksize; 
                var topcolor2 = toptext.add("group", undefined, {name: "color2"}); topcolor2.orientation = "row"; topcolor2.alignChildren = ["center","center"]; topcolor2.size = blocksize; 
                var topcolor3 = toptext.add("group", undefined, {name: "color3"}); topcolor3.orientation = "row"; topcolor3.alignChildren = ["center","center"]; topcolor3.size = blocksize; 
                var topcolor4 = toptext.add("group", undefined, {name: "color4"}); topcolor4.orientation = "row"; topcolor4.alignChildren = ["center","center"]; topcolor4.size = blocksize; 

            function selectedColors(){
                if(nopref == 1){
                        topcolor1.graphics.backgroundColor = topcolor1.graphics.newBrush(topcolor1.graphics.BrushType.SOLID_COLOR, [0.5,0.5,0.5,1]);
                    }else{ 
                        topcolor1.graphics.backgroundColor = topcolor1.graphics.newBrush(topcolor1.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[currentcolor-1][0],getLabelsFromPrefsToRGBA()[currentcolor-1][1],getLabelsFromPrefsToRGBA()[currentcolor-1][2],1]); }
                if(noprefa == 1){
                        topcolor2.graphics.backgroundColor = topcolor2.graphics.newBrush(topcolor2.graphics.BrushType.SOLID_COLOR, [0.5,0.5,0.5,1]);
                    }else{ 
                        topcolor2.graphics.backgroundColor = topcolor2.graphics.newBrush(topcolor2.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[currentcolora-1][0],getLabelsFromPrefsToRGBA()[currentcolora-1][1],getLabelsFromPrefsToRGBA()[currentcolora-1][2],1]); }
                if(noprefb == 1){
                        topcolor3.graphics.backgroundColor = topcolor3.graphics.newBrush(topcolor3.graphics.BrushType.SOLID_COLOR, [0.5,0.5,0.5,1]);
                    }else{ 
                        topcolor3.graphics.backgroundColor = topcolor3.graphics.newBrush(topcolor3.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[currentcolorb-1][0],getLabelsFromPrefsToRGBA()[currentcolorb-1][1],getLabelsFromPrefsToRGBA()[currentcolorb-1][2],1]); }
                if(noprefc == 1){
                        topcolor4.graphics.backgroundColor = topcolor4.graphics.newBrush(topcolor4.graphics.BrushType.SOLID_COLOR, [0.5,0.5,0.5,1]);
                    }else{ 
                        topcolor4.graphics.backgroundColor = topcolor4.graphics.newBrush(topcolor4.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[currentcolorc-1][0],getLabelsFromPrefsToRGBA()[currentcolorc-1][1],getLabelsFromPrefsToRGBA()[currentcolorc-1][2],1]); }
            }
            selectedColors();

                // Row 0
                // ======
                var row0 = dialog.add("group", undefined, {name: "group1"}); 
                    row0.orientation = "row"; 
                    row0.alignChildren = ["left","center"]; 
                    row0.spacing = 4; 
                    row0.margins = 4; 
                    
                // Column 1
                // ======
                var row1 = row0.add("group", undefined, {name: "group1"}); 
                    row1.orientation = "column"; 
                    row1.alignChildren = ["left","center"]; 
                    row1.spacing = 4; 
                    row1.margins = 4; 
                // textrow 1
                // ======
                var textrow1 = row1.add("group", undefined, {name: "group1"}); textrow1.orientation = "row"; textrow1.alignChildren = ["left","bottom"]; textrow1.spacing = 4; textrow1.margins = 0; 
                var statictext1 = textrow1.add('statictext {properties: {name: ""}}'); statictext1.spacing = 4; statictext1.size = radiosize; statictext1.align = ["center","center"]; statictext1.text = ' 1';
                var statictext2 = textrow1.add('statictext {properties: {name: ""}}'); statictext2.spacing = 4; statictext2.size = radiosize; statictext2.align = ["center","center"]; statictext2.text = ' 2';
                var statictext3 = textrow1.add('statictext {properties: {name: ""}}'); statictext3.spacing = 4; statictext3.size = radiosize; statictext3.align = ["center","center"]; statictext3.text = ' 3';
                var statictext4 = textrow1.add('statictext {properties: {name: ""}}'); statictext4.spacing = 4; statictext4.size = radiosize; statictext4.align = ["center","center"]; statictext4.text = ' 4';
{
                                // button 1
                                // ======
                                var button1row = row1.add("group", undefined, {name: "button1row"}); button1row.spacing = 4; button1row.margins = 0; button1row.orientation = "row";
                                var button1 = button1row.add("group", undefined, {name: "button1"}); button1.spacing = 4; button1.margins = 0;
                                var button1a = button1row.add("group", undefined, {name: "button1"}); button1a.spacing = 4; button1a.margins = 0;
                                var button1b = button1row.add("group", undefined, {name: "button1"}); button1b.spacing = 4; button1b.margins = 0;
                                var button1c = button1row.add("group", undefined, {name: "button1"}); button1c.spacing = 4; button1c.margins = 0; 
                                var num = 0; 
                                var radiobutton1 = button1.add("radiobutton", undefined, undefined, {name: "radiobutton1"}); radiobutton1.alignChildren =  radioalign; radiobutton1.size = radiosize; 
                                var radiobutton1a = button1a.add("radiobutton", undefined, undefined, {name: "radiobutton1a"}); radiobutton1a.alignChildren =  radioalign; radiobutton1a.size = radiosize; 
                                var radiobutton1b = button1b.add("radiobutton", undefined, undefined, {name: "radiobutton1b"}); radiobutton1b.alignChildren =  radioalign; radiobutton1b.size = radiosize; 
                                var radiobutton1c = button1c.add("radiobutton", undefined, undefined, {name: "radiobutton1c"}); radiobutton1c.alignChildren =  radioalign; radiobutton1c.size = radiosize; 

                                // color 1
                                // ======
                                var color1 = button1row.add("group", undefined, {name: "color1"}); color1.orientation = "row"; color1.alignChildren = ["center","center"]; color1.size = blocksize; 
                                    color1.graphics.backgroundColor =color1.graphics.newBrush(color1.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext1 = button1row.add('statictext {properties: {name: ""}}'); statictext1.size = rowsize; statictext1.text = getLabelNamesFromPrefs()[num];

                                // button 2
                                // ======
                                var button2row = row1.add("group", undefined, {name: "button2row"}); button2row.spacing = 4; button2row.margins = 0; button2row.orientation = "row";
                                var button2 = button2row.add("group", undefined, {name: "button2"}); button2.spacing = 4; button2.margins = 0;
                                var button2a = button2row.add("group", undefined, {name: "button2"}); button2a.spacing = 4; button2a.margins = 0;
                                var button2b = button2row.add("group", undefined, {name: "button2"}); button2b.spacing = 4; button2b.margins = 0;
                                var button2c = button2row.add("group", undefined, {name: "button2"}); button2c.spacing = 4; button2c.margins = 0; 
                                var num = 1; 
                                var radiobutton2 = button2.add("radiobutton", undefined, undefined, {name: "radiobutton2"}); radiobutton2.alignChildren =  radioalign; radiobutton2.size = radiosize; 
                                var radiobutton2a = button2a.add("radiobutton", undefined, undefined, {name: "radiobutton2a"}); radiobutton2a.alignChildren =  radioalign; radiobutton2a.size = radiosize; 
                                var radiobutton2b = button2b.add("radiobutton", undefined, undefined, {name: "radiobutton2b"}); radiobutton2b.alignChildren =  radioalign; radiobutton2b.size = radiosize; 
                                var radiobutton2c = button2c.add("radiobutton", undefined, undefined, {name: "radiobutton2c"}); radiobutton2c.alignChildren =  radioalign; radiobutton2c.size = radiosize; 

                                // color 2
                                // ======
                                var color2 = button2row.add("group", undefined, {name: "color2"}); color2.orientation = "row"; color2.alignChildren = ["left","center"]; color2.size = blocksize;
                                    color2.graphics.backgroundColor =color2.graphics.newBrush(color2.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext2 = button2row.add('statictext {properties: {name: "statictext2"}}'); statictext2.text = getLabelNamesFromPrefs()[num];
                                    
                                // button 3
                                // ======
                                var button3row = row1.add("group", undefined, {name: "button3row"}); button3row.spacing = 4; button3row.margins = 0; button3row.orientation = "row";
                                var button3 = button3row.add("group", undefined, {name: "button3"}); button3.spacing = 4; button3.margins = 0;
                                var button3a = button3row.add("group", undefined, {name: "button3"}); button3a.spacing = 4; button3a.margins = 0;
                                var button3b = button3row.add("group", undefined, {name: "button3"}); button3b.spacing = 4; button3b.margins = 0;
                                var button3c = button3row.add("group", undefined, {name: "button3"}); button3c.spacing = 4; button3c.margins = 0; 
                                var num = 2; 
                                var radiobutton3 = button3.add("radiobutton", undefined, undefined, {name: "radiobutton3"}); radiobutton3.alignChildren =  radioalign; radiobutton3.size = radiosize; 
                                var radiobutton3a = button3a.add("radiobutton", undefined, undefined, {name: "radiobutton3a"}); radiobutton3a.alignChildren =  radioalign; radiobutton3a.size = radiosize; 
                                var radiobutton3b = button3b.add("radiobutton", undefined, undefined, {name: "radiobutton3b"}); radiobutton3b.alignChildren =  radioalign; radiobutton3b.size = radiosize; 
                                var radiobutton3c = button3c.add("radiobutton", undefined, undefined, {name: "radiobutton3c"}); radiobutton3c.alignChildren =  radioalign; radiobutton3c.size = radiosize; 

                                // color 3
                                // ======
                                var color3 = button3row.add("group", undefined, {name: "color3"}); color3.orientation = "row"; color3.alignChildren = ["left","center"]; color3.size = blocksize; 
                                    color3.graphics.backgroundColor =color3.graphics.newBrush(color3.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext3 = button3row.add('statictext {properties: {name: "statictext3"}}');  statictext3.text = getLabelNamesFromPrefs()[num];

                                // button 4
                                // ======
                                var button4row = row1.add("group", undefined, {name: "button4row"}); button4row.spacing = 4; button4row.margins = 0; button4row.orientation = "row";
                                var button4 = button4row.add("group", undefined, {name: "button4"}); button4.spacing = 4; button4.margins = 0;
                                var button4a = button4row.add("group", undefined, {name: "button4"}); button4a.spacing = 4; button4a.margins = 0;
                                var button4b = button4row.add("group", undefined, {name: "button4"}); button4b.spacing = 4; button4b.margins = 0;
                                var button4c = button4row.add("group", undefined, {name: "button4"}); button4c.spacing = 4; button4c.margins = 0; 
                                var num = 3; 
                                var radiobutton4 = button4.add("radiobutton", undefined, undefined, {name: "radiobutton4"}); radiobutton4.alignChildren =  radioalign; radiobutton4.size = radiosize; 
                                var radiobutton4a = button4a.add("radiobutton", undefined, undefined, {name: "radiobutton4a"}); radiobutton4a.alignChildren =  radioalign; radiobutton4a.size = radiosize; 
                                var radiobutton4b = button4b.add("radiobutton", undefined, undefined, {name: "radiobutton4b"}); radiobutton4b.alignChildren =  radioalign; radiobutton4b.size = radiosize; 
                                var radiobutton4c = button4c.add("radiobutton", undefined, undefined, {name: "radiobutton4c"}); radiobutton4c.alignChildren =  radioalign; radiobutton4c.size = radiosize; 
                                
                                // color 4
                                // ======
                                var color4 = button4row.add("group", undefined, {name: "color3"}); color4.orientation = "row"; color4.alignChildren = ["left","center"]; color4.size = blocksize;
                                    color4.graphics.backgroundColor =color4.graphics.newBrush(color4.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext4 = button4row.add('statictext {properties: {name: "statictext3"}}'); statictext4.text = getLabelNamesFromPrefs()[num];
}
                // Column 2
                // ======
                var row2 = row0.add("group", undefined, {name: "group1"}); 
                    row2.orientation = "column"; 
                    row2.alignChildren = ["left","center"]; 
                    row2.spacing = 4; 
                    row2.margins = 4; 
                // textrow 2
                // ======
                var textrow2 = row2.add("group", undefined, {name: "group1"}); textrow2.orientation = "row"; textrow2.alignChildren = ["left","bottom"]; textrow2.spacing = 4; textrow2.margins = 0; 
                var statictext1 = textrow2.add('statictext {properties: {name: ""}}'); statictext1.spacing = 4; statictext1.size = radiosize; statictext1.align = ["center","center"]; statictext1.text = ' 1';
                var statictext2 = textrow2.add('statictext {properties: {name: ""}}'); statictext2.spacing = 4; statictext2.size = radiosize; statictext2.align = ["center","center"]; statictext2.text = ' 2';
                var statictext3 = textrow2.add('statictext {properties: {name: ""}}'); statictext3.spacing = 4; statictext3.size = radiosize; statictext3.align = ["center","center"]; statictext3.text = ' 3';
                var statictext4 = textrow2.add('statictext {properties: {name: ""}}'); statictext4.spacing = 4; statictext4.size = radiosize; statictext4.align = ["center","center"]; statictext4.text = ' 4';
{
                                // button 1
                                // ======
                                var button5row = row2.add("group", undefined, {name: "button5row"}); button5row.spacing = 4; button5row.margins = 0; button5row.orientation = "row";
                                var button5 = button5row.add("group", undefined, {name: "button5"}); button5.spacing = 4; button5.margins = 0;
                                var button5a = button5row.add("group", undefined, {name: "button5"}); button5a.spacing = 4; button5a.margins = 0;
                                var button5b = button5row.add("group", undefined, {name: "button5"}); button5b.spacing = 4; button5b.margins = 0;
                                var button5c = button5row.add("group", undefined, {name: "button5"}); button5c.spacing = 4; button5c.margins = 0; 
                                var num = 4; 
                                var radiobutton5 = button5.add("radiobutton", undefined, undefined, {name: "radiobutton5"}); radiobutton5.alignChildren =  radioalign; radiobutton5.size = radiosize; 
                                var radiobutton5a = button5a.add("radiobutton", undefined, undefined, {name: "radiobutton5a"}); radiobutton5a.alignChildren =  radioalign; radiobutton5a.size = radiosize; 
                                var radiobutton5b = button5b.add("radiobutton", undefined, undefined, {name: "radiobutton5b"}); radiobutton5b.alignChildren =  radioalign; radiobutton5b.size = radiosize; 
                                var radiobutton5c = button5c.add("radiobutton", undefined, undefined, {name: "radiobutton5c"}); radiobutton5c.alignChildren =  radioalign; radiobutton5c.size = radiosize; 

                                // color 1
                                // ======
                                var color1 = button5row.add("group", undefined, {name: "color1"}); color1.orientation = "row"; color1.alignChildren = ["left","center"]; color1.size = blocksize;
                                    color1.graphics.backgroundColor =color1.graphics.newBrush(color1.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext1 = button5row.add('statictext {properties: {name: "statictext1"}}'); statictext1.size = rowsize; statictext1.text = getLabelNamesFromPrefs()[num];

                                // button 2
                                // ======
                                var button6row = row2.add("group", undefined, {name: "button6row"}); button6row.spacing = 4; button6row.margins = 0; button6row.orientation = "row";
                                var button6 = button6row.add("group", undefined, {name: "button6"}); button6.spacing = 4; button6.margins = 0;
                                var button6a = button6row.add("group", undefined, {name: "button6"}); button6a.spacing = 4; button6a.margins = 0;
                                var button6b = button6row.add("group", undefined, {name: "button6"}); button6b.spacing = 4; button6b.margins = 0;
                                var button6c = button6row.add("group", undefined, {name: "button6"}); button6c.spacing = 4; button6c.margins = 0; 
                                var num = 5; 
                                var radiobutton6 = button6.add("radiobutton", undefined, undefined, {name: "radiobutton6"}); radiobutton6.alignChildren =  radioalign; radiobutton6.size = radiosize; 
                                var radiobutton6a = button6a.add("radiobutton", undefined, undefined, {name: "radiobutton6a"}); radiobutton6a.alignChildren =  radioalign; radiobutton6a.size = radiosize; 
                                var radiobutton6b = button6b.add("radiobutton", undefined, undefined, {name: "radiobutton6b"}); radiobutton6b.alignChildren =  radioalign; radiobutton6b.size = radiosize; 
                                var radiobutton6c = button6c.add("radiobutton", undefined, undefined, {name: "radiobutton6c"}); radiobutton6c.alignChildren =  radioalign; radiobutton6c.size = radiosize; 

                                // color 2
                                // ======
                                var color2 = button6row.add("group", undefined, {name: "color2"}); color2.orientation = "row"; color2.alignChildren = ["left","center"]; color2.size = blocksize;
                                    color2.graphics.backgroundColor =color2.graphics.newBrush(color2.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext2 = button6row.add('statictext {properties: {name: "statictext2"}}'); statictext2.text = getLabelNamesFromPrefs()[num];

                                // button 3
                                // ======
                                var button7row = row2.add("group", undefined, {name: "button7row"}); button7row.spacing = 4; button7row.margins = 0; button7row.orientation = "row";
                                var button7 = button7row.add("group", undefined, {name: "button7"}); button7.spacing = 4; button7.margins = 0;
                                var button7a = button7row.add("group", undefined, {name: "button7"}); button7a.spacing = 4; button7a.margins = 0;
                                var button7b = button7row.add("group", undefined, {name: "button7"}); button7b.spacing = 4; button7b.margins = 0;
                                var button7c = button7row.add("group", undefined, {name: "button7"}); button7c.spacing = 4; button7c.margins = 0; 
                                var num = 6; 
                                var radiobutton7 = button7.add("radiobutton", undefined, undefined, {name: "radiobutton7"}); radiobutton7.alignChildren =  radioalign; radiobutton7.size = radiosize; 
                                var radiobutton7a = button7a.add("radiobutton", undefined, undefined, {name: "radiobutton7a"}); radiobutton7a.alignChildren =  radioalign; radiobutton7a.size = radiosize; 
                                var radiobutton7b = button7b.add("radiobutton", undefined, undefined, {name: "radiobutton7b"}); radiobutton7b.alignChildren =  radioalign; radiobutton7b.size = radiosize; 
                                var radiobutton7c = button7c.add("radiobutton", undefined, undefined, {name: "radiobutton7c"}); radiobutton7c.alignChildren =  radioalign; radiobutton7c.size = radiosize; 

                                // color 3
                                // ======
                                var color3 = button7row.add("group", undefined, {name: "color3"}); color3.orientation = "row"; color3.alignChildren = ["left","center"]; color3.size = blocksize;
                                    color3.graphics.backgroundColor =color3.graphics.newBrush(color3.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext3 = button7row.add('statictext {properties: {name: "statictext3"}}'); statictext3.text = getLabelNamesFromPrefs()[num];

                                // button 4
                                // ======
                                var button8row = row2.add("group", undefined, {name: "button8row"}); button8row.spacing = 4; button8row.margins = 0; button8row.orientation = "row";
                                var button8 = button8row.add("group", undefined, {name: "button8"}); button8.spacing = 4; button8.margins = 0;
                                var button8a = button8row.add("group", undefined, {name: "button8"}); button8a.spacing = 4; button8a.margins = 0;
                                var button8b = button8row.add("group", undefined, {name: "button8"}); button8b.spacing = 4; button8b.margins = 0;
                                var button8c = button8row.add("group", undefined, {name: "button8"}); button8c.spacing = 4; button8c.margins = 0; 
                                var num = 7; 
                                var radiobutton8 = button8.add("radiobutton", undefined, undefined, {name: "radiobutton8"}); radiobutton8.alignChildren =  radioalign; radiobutton8.size = radiosize; 
                                var radiobutton8a = button8a.add("radiobutton", undefined, undefined, {name: "radiobutton8a"}); radiobutton8a.alignChildren =  radioalign; radiobutton8a.size = radiosize; 
                                var radiobutton8b = button8b.add("radiobutton", undefined, undefined, {name: "radiobutton8b"}); radiobutton8b.alignChildren =  radioalign; radiobutton8b.size = radiosize; 
                                var radiobutton8c = button8c.add("radiobutton", undefined, undefined, {name: "radiobutton8c"}); radiobutton8c.alignChildren =  radioalign; radiobutton8c.size = radiosize; 
                                
                                // color 4
                                // ======
                                var color4 = button8row.add("group", undefined, {name: "color3"}); color4.orientation = "row"; color4.alignChildren = ["left","center"]; color4.size = blocksize;
                                    color4.graphics.backgroundColor =color4.graphics.newBrush(color4.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);

                                var statictext4 = button8row.add('statictext {properties: {name: "statictext3"}}'); statictext4.text = getLabelNamesFromPrefs()[num];
}
                // Column 3
                // ======
                var row3 = row0.add("group", undefined, {name: "group1"}); 
                    row3.orientation = "column"; 
                    row3.alignChildren = ["left","center"]; 
                    row3.spacing = 4; 
                    row3.margins = 4; 
                // textrow 3
                // ======
                var textrow3 = row3.add("group", undefined, {name: "group1"}); textrow3.orientation = "row"; textrow3.alignChildren = ["left","bottom"]; textrow3.spacing = 4; textrow3.margins = 0; 
                var statictext1 = textrow3.add('statictext {properties: {name: ""}}'); statictext1.spacing = 4; statictext1.size = radiosize; statictext1.align = ["center","center"]; statictext1.text = ' 1';
                var statictext2 = textrow3.add('statictext {properties: {name: ""}}'); statictext2.spacing = 4; statictext2.size = radiosize; statictext2.align = ["center","center"]; statictext2.text = ' 2';
                var statictext3 = textrow3.add('statictext {properties: {name: ""}}'); statictext3.spacing = 4; statictext3.size = radiosize; statictext3.align = ["center","center"]; statictext3.text = ' 3';
                var statictext4 = textrow3.add('statictext {properties: {name: ""}}'); statictext4.spacing = 4; statictext4.size = radiosize; statictext4.align = ["center","center"]; statictext4.text = ' 4';
{
                                // button 1
                                // ======
                                var button9row = row3.add("group", undefined, {name: "button9row"}); button9row.spacing = 4; button9row.margins = 0; button9row.orientation = "row";
                                var button9 = button9row.add("group", undefined, {name: "button9"}); button9.spacing = 4; button9.margins = 0;
                                var button9a = button9row.add("group", undefined, {name: "button9"}); button9a.spacing = 4; button9a.margins = 0;
                                var button9b = button9row.add("group", undefined, {name: "button9"}); button9b.spacing = 4; button9b.margins = 0;
                                var button9c = button9row.add("group", undefined, {name: "button9"}); button9c.spacing = 4; button9c.margins = 0; 
                                var num = 8; 
                                var radiobutton9 = button9.add("radiobutton", undefined, undefined, {name: "radiobutton9"}); radiobutton9.alignChildren =  radioalign; radiobutton9.size = radiosize; 
                                var radiobutton9a = button9a.add("radiobutton", undefined, undefined, {name: "radiobutton9a"}); radiobutton9a.alignChildren =  radioalign; radiobutton9a.size = radiosize; 
                                var radiobutton9b = button9b.add("radiobutton", undefined, undefined, {name: "radiobutton9b"}); radiobutton9b.alignChildren =  radioalign; radiobutton9b.size = radiosize; 
                                var radiobutton9c = button9c.add("radiobutton", undefined, undefined, {name: "radiobutton9c"}); radiobutton9c.alignChildren =  radioalign; radiobutton9c.size = radiosize; 

                                // color 1
                                // ======
                                var color1 = button9row.add("group", undefined, {name: "color1"}); color1.orientation = "row"; color1.alignChildren = ["left","center"]; color1.size = blocksize;
                                    color1.graphics.backgroundColor =color1.graphics.newBrush(color1.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext1 = button9row.add('statictext {properties: {name: "statictext1"}}'); statictext1.size = rowsize; statictext1.text = getLabelNamesFromPrefs()[num];

                                // button 2
                                // ======
                                var button10row = row3.add("group", undefined, {name: "button10row"}); button10row.spacing = 4; button10row.margins = 0; button10row.orientation = "row";
                                var button10 = button10row.add("group", undefined, {name: "button10"}); button10.spacing = 4; button10.margins = 0;
                                var button10a = button10row.add("group", undefined, {name: "button10"}); button10a.spacing = 4; button10a.margins = 0;
                                var button10b = button10row.add("group", undefined, {name: "button10"}); button10b.spacing = 4; button10b.margins = 0;
                                var button10c = button10row.add("group", undefined, {name: "button10"}); button10c.spacing = 4; button10c.margins = 0; 
                                var num = 9; 
                                var radiobutton10 = button10.add("radiobutton", undefined, undefined, {name: "radiobutton10"}); radiobutton10.alignChildren =  radioalign; radiobutton10.size = radiosize; 
                                var radiobutton10a = button10a.add("radiobutton", undefined, undefined, {name: "radiobutton10a"}); radiobutton10a.alignChildren =  radioalign; radiobutton10a.size = radiosize; 
                                var radiobutton10b = button10b.add("radiobutton", undefined, undefined, {name: "radiobutton10b"}); radiobutton10b.alignChildren =  radioalign; radiobutton10b.size = radiosize; 
                                var radiobutton10c = button10c.add("radiobutton", undefined, undefined, {name: "radiobutton10c"}); radiobutton10c.alignChildren =  radioalign; radiobutton10c.size = radiosize; 

                                // color 2
                                // ======
                                var color2 = button10row.add("group", undefined, {name: "color2"}); color2.orientation = "row"; color2.alignChildren = ["left","center"]; color2.size = blocksize;
                                    color2.graphics.backgroundColor =color2.graphics.newBrush(color2.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext2 = button10row.add('statictext {properties: {name: "statictext2"}}'); statictext2.text = getLabelNamesFromPrefs()[num];

                                // button 3
                                // ======
                                var button11row = row3.add("group", undefined, {name: "button11row"}); button11row.spacing = 4; button11row.margins = 0; button11row.orientation = "row";
                                var button11 = button11row.add("group", undefined, {name: "button11"}); button11.spacing = 4; button11.margins = 0;
                                var button11a = button11row.add("group", undefined, {name: "button11"}); button11a.spacing = 4; button11a.margins = 0;
                                var button11b = button11row.add("group", undefined, {name: "button11"}); button11b.spacing = 4; button11b.margins = 0;
                                var button11c = button11row.add("group", undefined, {name: "button11"}); button11c.spacing = 4; button11c.margins = 0; 
                                var num = 10; 
                                var radiobutton11 = button11.add("radiobutton", undefined, undefined, {name: "radiobutton11"}); radiobutton11.alignChildren =  radioalign; radiobutton11.size = radiosize; 
                                var radiobutton11a = button11a.add("radiobutton", undefined, undefined, {name: "radiobutton11a"}); radiobutton11a.alignChildren =  radioalign; radiobutton11a.size = radiosize; 
                                var radiobutton11b = button11b.add("radiobutton", undefined, undefined, {name: "radiobutton11b"}); radiobutton11b.alignChildren =  radioalign; radiobutton11b.size = radiosize; 
                                var radiobutton11c = button11c.add("radiobutton", undefined, undefined, {name: "radiobutton11c"}); radiobutton11c.alignChildren =  radioalign; radiobutton11c.size = radiosize; 

                                // color 3
                                // ======
                                var color3 = button11row.add("group", undefined, {name: "color3"}); color3.orientation = "row"; color3.alignChildren = ["left","center"]; color3.size = blocksize;
                                    color3.graphics.backgroundColor =color3.graphics.newBrush(color3.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext3 = button11row.add('statictext {properties: {name: "statictext3"}}'); statictext3.text = getLabelNamesFromPrefs()[num];

                                // button 4
                                // ======
                                var button12row = row3.add("group", undefined, {name: "button12row"}); button12row.spacing = 4; button12row.margins = 0; button12row.orientation = "row";
                                var button12 = button12row.add("group", undefined, {name: "button12"}); button12.spacing = 4; button12.margins = 0;
                                var button12a = button12row.add("group", undefined, {name: "button12"}); button12a.spacing = 4; button12a.margins = 0;
                                var button12b = button12row.add("group", undefined, {name: "button12"}); button12b.spacing = 4; button12b.margins = 0;
                                var button12c = button12row.add("group", undefined, {name: "button12"}); button12c.spacing = 4; button12c.margins = 0; 
                                var num = 11; 
                                var radiobutton12 = button12.add("radiobutton", undefined, undefined, {name: "radiobutton12"}); radiobutton12.alignChildren =  radioalign; radiobutton12.size = radiosize; 
                                var radiobutton12a = button12a.add("radiobutton", undefined, undefined, {name: "radiobutton12a"}); radiobutton12a.alignChildren =  radioalign; radiobutton12a.size = radiosize; 
                                var radiobutton12b = button12b.add("radiobutton", undefined, undefined, {name: "radiobutton12b"}); radiobutton12b.alignChildren =  radioalign; radiobutton12b.size = radiosize; 
                                var radiobutton12c = button12c.add("radiobutton", undefined, undefined, {name: "radiobutton12c"}); radiobutton12c.alignChildren =  radioalign; radiobutton12c.size = radiosize; 
                                
                                // color 4
                                // ======
                                var color4 = button12row.add("group", undefined, {name: "color3"}); color4.orientation = "row"; color4.alignChildren = ["left","center"]; color4.size = blocksize;
                                    color4.graphics.backgroundColor =color4.graphics.newBrush(color4.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext4 = button12row.add('statictext {properties: {name: "statictext3"}}'); statictext4.text = getLabelNamesFromPrefs()[num];
}
                // Column 4
                // ======
                var row4 = row0.add("group", undefined, {name: "group1"}); 
                    row4.orientation = "column"; 
                    row4.alignChildren = ["left","center"]; 
                    row4.spacing = 4; 
                    row4.margins = 4; 
                // textrow 4
                // ======
                var textrow4 = row4.add("group", undefined, {name: "group1"}); textrow4.orientation = "row"; textrow4.alignChildren = ["left","bottom"]; textrow4.spacing = 4; textrow4.margins = 0; 
                var statictext1 = textrow4.add('statictext {properties: {name: ""}}'); statictext1.spacing = 4; statictext1.size = radiosize; statictext1.align = ["center","center"]; statictext1.text = ' 1';
                var statictext2 = textrow4.add('statictext {properties: {name: ""}}'); statictext2.spacing = 4; statictext2.size = radiosize; statictext2.align = ["center","center"]; statictext2.text = ' 2';
                var statictext3 = textrow4.add('statictext {properties: {name: ""}}'); statictext3.spacing = 4; statictext3.size = radiosize; statictext3.align = ["center","center"]; statictext3.text = ' 3';
                var statictext4 = textrow4.add('statictext {properties: {name: ""}}'); statictext4.spacing = 4; statictext4.size = radiosize; statictext4.align = ["center","center"]; statictext4.text = ' 4';
{
                                // button 1
                                // ======
                                var button13row = row4.add("group", undefined, {name: "button13row"}); button13row.spacing = 4; button13row.margins = 0; button13row.orientation = "row";
                                var button13 = button13row.add("group", undefined, {name: "button13"}); button13.spacing = 4; button13.margins = 0;
                                var button13a = button13row.add("group", undefined, {name: "button13"}); button13a.spacing = 4; button13a.margins = 0;
                                var button13b = button13row.add("group", undefined, {name: "button13"}); button13b.spacing = 4; button13b.margins = 0;
                                var button13c = button13row.add("group", undefined, {name: "button13"}); button13c.spacing = 4; button13c.margins = 0; 
                                var num = 12; 
                                var radiobutton13 = button13.add("radiobutton", undefined, undefined, {name: "radiobutton13"}); radiobutton13.alignChildren =  radioalign; radiobutton13.size = radiosize; 
                                var radiobutton13a = button13a.add("radiobutton", undefined, undefined, {name: "radiobutton13a"}); radiobutton13a.alignChildren =  radioalign; radiobutton13a.size = radiosize; 
                                var radiobutton13b = button13b.add("radiobutton", undefined, undefined, {name: "radiobutton13b"}); radiobutton13b.alignChildren =  radioalign; radiobutton13b.size = radiosize; 
                                var radiobutton13c = button13c.add("radiobutton", undefined, undefined, {name: "radiobutton13c"}); radiobutton13c.alignChildren =  radioalign; radiobutton13c.size = radiosize; 

                                // color 1
                                // ======
                                var color1 = button13row.add("group", undefined, {name: "color1"}); color1.orientation = "row"; color1.alignChildren = ["left","center"]; color1.size = blocksize;
                                    color1.graphics.backgroundColor =color1.graphics.newBrush(color1.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext1 = button13row.add('statictext {properties: {name: "statictext1"}}'); statictext1.size = rowsize; statictext1.text = getLabelNamesFromPrefs()[num];

                                // button 2
                                // ======
                                var button14row = row4.add("group", undefined, {name: "button14row"}); button14row.spacing = 4; button14row.margins = 0; button14row.orientation = "row";
                                var button14 = button14row.add("group", undefined, {name: "button14"}); button14.spacing = 4; button14.margins = 0;
                                var button14a = button14row.add("group", undefined, {name: "button14"}); button14a.spacing = 4; button14a.margins = 0;
                                var button14b = button14row.add("group", undefined, {name: "button14"}); button14b.spacing = 4; button14b.margins = 0;
                                var button14c = button14row.add("group", undefined, {name: "button14"}); button14c.spacing = 4; button14c.margins = 0; 
                                var num = 13; 
                                var radiobutton14 = button14.add("radiobutton", undefined, undefined, {name: "radiobutton14"}); radiobutton14.alignChildren =  radioalign; radiobutton14.size = radiosize; 
                                var radiobutton14a = button14a.add("radiobutton", undefined, undefined, {name: "radiobutton14a"}); radiobutton14a.alignChildren =  radioalign; radiobutton14a.size = radiosize; 
                                var radiobutton14b = button14b.add("radiobutton", undefined, undefined, {name: "radiobutton14b"}); radiobutton14b.alignChildren =  radioalign; radiobutton14b.size = radiosize; 
                                var radiobutton14c = button14c.add("radiobutton", undefined, undefined, {name: "radiobutton14c"}); radiobutton14c.alignChildren =  radioalign; radiobutton14c.size = radiosize; 

                                // color 2
                                // ======
                                var color2 = button14row.add("group", undefined, {name: "color2"}); color2.orientation = "row"; color2.alignChildren = ["left","center"]; color2.size = blocksize;
                                    color2.graphics.backgroundColor =color2.graphics.newBrush(color2.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext2 = button14row.add('statictext {properties: {name: "statictext2"}}'); statictext2.text = getLabelNamesFromPrefs()[num];

                                // button 3
                                // ======
                                var button15row = row4.add("group", undefined, {name: "button15row"}); button15row.spacing = 4; button15row.margins = 0; button15row.orientation = "row";
                                var button15 = button15row.add("group", undefined, {name: "button15"}); button15.spacing = 4; button15.margins = 0;
                                var button15a = button15row.add("group", undefined, {name: "button15"}); button15a.spacing = 4; button15a.margins = 0;
                                var button15b = button15row.add("group", undefined, {name: "button15"}); button15b.spacing = 4; button15b.margins = 0;
                                var button15c = button15row.add("group", undefined, {name: "button15"}); button15c.spacing = 4; button15c.margins = 0; 
                                var num = 14; 
                                var radiobutton15 = button15.add("radiobutton", undefined, undefined, {name: "radiobutton15"}); radiobutton15.alignChildren =  radioalign; radiobutton15.size = radiosize; 
                                var radiobutton15a = button15a.add("radiobutton", undefined, undefined, {name: "radiobutton15a"}); radiobutton15a.alignChildren =  radioalign; radiobutton15a.size = radiosize; 
                                var radiobutton15b = button15b.add("radiobutton", undefined, undefined, {name: "radiobutton15b"}); radiobutton15b.alignChildren =  radioalign; radiobutton15b.size = radiosize; 
                                var radiobutton15c = button15c.add("radiobutton", undefined, undefined, {name: "radiobutton15c"}); radiobutton15c.alignChildren =  radioalign; radiobutton15c.size = radiosize; 

                                // color 3
                                // ======
                                var color3 = button15row.add("group", undefined, {name: "color3"}); color3.orientation = "row"; color3.alignChildren = ["left","center"]; color3.size = blocksize;
                                    color3.graphics.backgroundColor =color3.graphics.newBrush(color3.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext3 = button15row.add('statictext {properties: {name: "statictext3"}}'); statictext3.text = getLabelNamesFromPrefs()[num];

                                // button 4
                                // ======
                                var button16row = row4.add("group", undefined, {name: "button16row"}); button16row.spacing = 4; button16row.margins = 0; button16row.orientation = "row";
                                var button16 = button16row.add("group", undefined, {name: "button16"}); button16.spacing = 4; button16.margins = 0;
                                var button16a = button16row.add("group", undefined, {name: "button16"}); button16a.spacing = 4; button16a.margins = 0;
                                var button16b = button16row.add("group", undefined, {name: "button16"}); button16b.spacing = 4; button16b.margins = 0;
                                var button16c = button16row.add("group", undefined, {name: "button16"}); button16c.spacing = 4; button16c.margins = 0; 
                                var num = 15; 
                                var radiobutton16 = button16.add("radiobutton", undefined, undefined, {name: "radiobutton16"}); radiobutton16.alignChildren =  radioalign; radiobutton16.size = radiosize; 
                                var radiobutton16a = button16a.add("radiobutton", undefined, undefined, {name: "radiobutton16a"}); radiobutton16a.alignChildren =  radioalign; radiobutton16a.size = radiosize; 
                                var radiobutton16b = button16b.add("radiobutton", undefined, undefined, {name: "radiobutton16b"}); radiobutton16b.alignChildren =  radioalign; radiobutton16b.size = radiosize; 
                                var radiobutton16c = button16c.add("radiobutton", undefined, undefined, {name: "radiobutton16c"}); radiobutton16c.alignChildren =  radioalign; radiobutton16c.size = radiosize; 
                                
                                // color 4
                                // ======
                                var color4 = button16row.add("group", undefined, {name: "color3"}); color4.orientation = "row"; color4.alignChildren = ["left","center"]; color4.size = blocksize;
                                    color4.graphics.backgroundColor =color4.graphics.newBrush(color4.graphics.BrushType.SOLID_COLOR, [getLabelsFromPrefsToRGBA()[num][0],getLabelsFromPrefsToRGBA()[num][1],getLabelsFromPrefsToRGBA()[num][2],1]);
                                var statictext4 = button16row.add('statictext {properties: {name: "statictext3"}}'); statictext4.text = getLabelNamesFromPrefs()[num];
}


    // radiobuttons react
    // ======

radiobutton1.onClick = function(){currentcolor = 1;     nopref = 0;  checkValues();};
radiobutton2.onClick = function(){currentcolor = 2;     nopref = 0;  checkValues();};
radiobutton3.onClick = function(){currentcolor = 3;     nopref = 0;  checkValues();};
radiobutton4.onClick = function(){currentcolor = 4;     nopref = 0;  checkValues();};
radiobutton5.onClick = function(){currentcolor = 5;     nopref = 0;  checkValues();};
radiobutton6.onClick = function(){currentcolor = 6;     nopref = 0;  checkValues();};
radiobutton7.onClick = function(){currentcolor = 7;     nopref = 0;  checkValues();};
radiobutton8.onClick = function(){currentcolor = 8;     nopref = 0;  checkValues();};
radiobutton9.onClick = function(){currentcolor = 9;     nopref = 0;  checkValues();};
radiobutton10.onClick = function(){currentcolor = 10;     nopref = 0;  checkValues();};
radiobutton11.onClick = function(){currentcolor = 11;     nopref = 0;  checkValues();};
radiobutton12.onClick = function(){currentcolor = 12;     nopref = 0;  checkValues();};
radiobutton13.onClick = function(){currentcolor = 13;     nopref = 0;  checkValues();};
radiobutton14.onClick = function(){currentcolor = 14;     nopref = 0;  checkValues();};
radiobutton15.onClick = function(){currentcolor = 15;     nopref = 0;  checkValues();};
radiobutton16.onClick = function(){currentcolor = 16;     nopref = 0;  checkValues();};

function checkValues(){
//    if(currentcolor ==  0){radiobutton1.value = true;}else{radiobutton1.value = false;}
    if(currentcolor ==  1){radiobutton1.value = true;}else{radiobutton1.value = false;}
    if(currentcolor ==  2){radiobutton2.value = true;}else{radiobutton2.value = false;}
    if(currentcolor ==  3){radiobutton3.value = true;}else{radiobutton3.value = false;}
    if(currentcolor ==  4){radiobutton4.value = true;}else{radiobutton4.value = false;}
    if(currentcolor ==  5){radiobutton5.value = true;}else{radiobutton5.value = false;}
    if(currentcolor ==  6){radiobutton6.value = true;}else{radiobutton6.value = false;}
    if(currentcolor ==  7){radiobutton7.value = true;}else{radiobutton7.value = false;}
    if(currentcolor ==  8){radiobutton8.value = true;}else{radiobutton8.value = false;}
    if(currentcolor ==  9){radiobutton9.value = true;}else{radiobutton9.value = false;}
    if(currentcolor == 10){radiobutton10.value = true;}else{radiobutton10.value = false;}
    if(currentcolor == 11){radiobutton11.value = true;}else{radiobutton11.value = false;}
    if(currentcolor == 12){radiobutton12.value = true;}else{radiobutton12.value = false;}
    if(currentcolor == 13){radiobutton13.value = true;}else{radiobutton13.value = false;}
    if(currentcolor == 14){radiobutton14.value = true;}else{radiobutton14.value = false;}
    if(currentcolor == 15){radiobutton15.value = true;}else{radiobutton15.value = false;}
    if(currentcolor == 16){radiobutton16.value = true;}else{radiobutton16.value = false;}
    selectedColors();
}
checkValues();

// A
radiobutton1a.onClick = function(){currentcolora = 1;     noprefa = 0;  checkValuesA();};
radiobutton2a.onClick = function(){currentcolora = 2;     noprefa = 0;  checkValuesA();};
radiobutton3a.onClick = function(){currentcolora = 3;     noprefa = 0;  checkValuesA();};
radiobutton4a.onClick = function(){currentcolora = 4;     noprefa = 0;  checkValuesA();};
radiobutton5a.onClick = function(){currentcolora = 5;     noprefa = 0;  checkValuesA();};
radiobutton6a.onClick = function(){currentcolora = 6;     noprefa = 0;  checkValuesA();};
radiobutton7a.onClick = function(){currentcolora = 7;     noprefa = 0;  checkValuesA();};
radiobutton8a.onClick = function(){currentcolora = 8;     noprefa = 0;  checkValuesA();};
radiobutton9a.onClick = function(){currentcolora = 9;     noprefa = 0;  checkValuesA();};
radiobutton10a.onClick = function(){currentcolora = 10;     noprefa = 0;  checkValuesA();};
radiobutton11a.onClick = function(){currentcolora = 11;     noprefa = 0;  checkValuesA();};
radiobutton12a.onClick = function(){currentcolora = 12;     noprefa = 0;  checkValuesA();};
radiobutton13a.onClick = function(){currentcolora = 13;     noprefa = 0;  checkValuesA();};
radiobutton14a.onClick = function(){currentcolora = 14;     noprefa = 0;  checkValuesA();};
radiobutton15a.onClick = function(){currentcolora = 15;     noprefa = 0;  checkValuesA();};
radiobutton16a.onClick = function(){currentcolora = 16;     noprefa = 0;  checkValuesA();};

function checkValuesA(){
 //   if(currentcolora ==  0){radiobutton1a.value = true;}else{radiobutton1a.value = false;}
    if(currentcolora ==  1){radiobutton1a.value = true;}else{radiobutton1a.value = false;}
    if(currentcolora ==  2){radiobutton2a.value = true;}else{radiobutton2a.value = false;}
    if(currentcolora ==  3){radiobutton3a.value = true;}else{radiobutton3a.value = false;}
    if(currentcolora ==  4){radiobutton4a.value = true;}else{radiobutton4a.value = false;}
    if(currentcolora ==  5){radiobutton5a.value = true;}else{radiobutton5a.value = false;}
    if(currentcolora ==  6){radiobutton6a.value = true;}else{radiobutton6a.value = false;}
    if(currentcolora ==  7){radiobutton7a.value = true;}else{radiobutton7a.value = false;}
    if(currentcolora ==  8){radiobutton8a.value = true;}else{radiobutton8a.value = false;}
    if(currentcolora ==  9){radiobutton9a.value = true;}else{radiobutton9a.value = false;}
    if(currentcolora == 10){radiobutton10a.value = true;}else{radiobutton10a.value = false;}
    if(currentcolora == 11){radiobutton11a.value = true;}else{radiobutton11a.value = false;}
    if(currentcolora == 12){radiobutton12a.value = true;}else{radiobutton12a.value = false;}
    if(currentcolora == 13){radiobutton13a.value = true;}else{radiobutton13a.value = false;}
    if(currentcolora == 14){radiobutton14a.value = true;}else{radiobutton14a.value = false;}
    if(currentcolora == 15){radiobutton15a.value = true;}else{radiobutton15a.value = false;}
    if(currentcolora == 16){radiobutton16a.value = true;}else{radiobutton16a.value = false;}
    selectedColors();
}
checkValuesA();
// B
radiobutton1b.onClick = function(){currentcolorb = 1;     noprefb = 0;  checkValuesB();};
radiobutton2b.onClick = function(){currentcolorb = 2;     noprefb = 0;  checkValuesB();};
radiobutton3b.onClick = function(){currentcolorb = 3;     noprefb = 0;  checkValuesB();};
radiobutton4b.onClick = function(){currentcolorb = 4;     noprefb = 0;  checkValuesB();};
radiobutton5b.onClick = function(){currentcolorb = 5;     noprefb = 0;  checkValuesB();};
radiobutton6b.onClick = function(){currentcolorb = 6;     noprefb = 0;  checkValuesB();};
radiobutton7b.onClick = function(){currentcolorb = 7;     noprefb = 0;  checkValuesB();};
radiobutton8b.onClick = function(){currentcolorb = 8;     noprefb = 0;  checkValuesB();};
radiobutton9b.onClick = function(){currentcolorb = 9;     noprefb = 0;  checkValuesB();};
radiobutton10b.onClick = function(){currentcolorb = 10;     noprefb = 0;  checkValuesB();};
radiobutton11b.onClick = function(){currentcolorb = 11;     noprefb = 0;  checkValuesB();};
radiobutton12b.onClick = function(){currentcolorb = 12;     noprefb = 0;  checkValuesB();};
radiobutton13b.onClick = function(){currentcolorb = 13;     noprefb = 0;  checkValuesB();};
radiobutton14b.onClick = function(){currentcolorb = 14;     noprefb = 0;  checkValuesB();};
radiobutton15b.onClick = function(){currentcolorb = 15;     noprefb = 0;  checkValuesB();};
radiobutton16b.onClick = function(){currentcolorb = 16;     noprefb = 0;  checkValuesB();};

function checkValuesB(){
//    if(currentcolorb ==  0){radiobutton1b.value = true;}else{radiobutton1b.value = false;}
    if(currentcolorb ==  1){radiobutton1b.value = true;}else{radiobutton1b.value = false;}
    if(currentcolorb ==  2){radiobutton2b.value = true;}else{radiobutton2b.value = false;}
    if(currentcolorb ==  3){radiobutton3b.value = true;}else{radiobutton3b.value = false;}
    if(currentcolorb ==  4){radiobutton4b.value = true;}else{radiobutton4b.value = false;}
    if(currentcolorb ==  5){radiobutton5b.value = true;}else{radiobutton5b.value = false;}
    if(currentcolorb ==  6){radiobutton6b.value = true;}else{radiobutton6b.value = false;}
    if(currentcolorb ==  7){radiobutton7b.value = true;}else{radiobutton7b.value = false;}
    if(currentcolorb ==  8){radiobutton8b.value = true;}else{radiobutton8b.value = false;}
    if(currentcolorb ==  9){radiobutton9b.value = true;}else{radiobutton9b.value = false;}
    if(currentcolorb == 10){radiobutton10b.value = true;}else{radiobutton10b.value = false;}
    if(currentcolorb == 11){radiobutton11b.value = true;}else{radiobutton11b.value = false;}
    if(currentcolorb == 12){radiobutton12b.value = true;}else{radiobutton12b.value = false;}
    if(currentcolorb == 13){radiobutton13b.value = true;}else{radiobutton13b.value = false;}
    if(currentcolorb == 14){radiobutton14b.value = true;}else{radiobutton14b.value = false;}
    if(currentcolorb == 15){radiobutton15b.value = true;}else{radiobutton15b.value = false;}
    if(currentcolorb == 16){radiobutton16b.value = true;}else{radiobutton16b.value = false;}
    selectedColors();
}
checkValuesB();
// C
radiobutton1c.onClick = function(){currentcolorc = 1;     noprefc = 0;  checkValuesC();};
radiobutton2c.onClick = function(){currentcolorc = 2;     noprefc = 0;  checkValuesC();};
radiobutton3c.onClick = function(){currentcolorc = 3;     noprefc = 0;  checkValuesC();};
radiobutton4c.onClick = function(){currentcolorc = 4;     noprefc = 0;  checkValuesC();};
radiobutton5c.onClick = function(){currentcolorc = 5;     noprefc = 0;  checkValuesC();};
radiobutton6c.onClick = function(){currentcolorc = 6;     noprefc = 0;  checkValuesC();};
radiobutton7c.onClick = function(){currentcolorc = 7;     noprefc = 0;  checkValuesC();};
radiobutton8c.onClick = function(){currentcolorc = 8;     noprefc = 0;  checkValuesC();};
radiobutton9c.onClick = function(){currentcolorc = 9;     noprefc = 0;  checkValuesC();};
radiobutton10c.onClick = function(){currentcolorc = 10;     noprefc = 0;  checkValuesC();};
radiobutton11c.onClick = function(){currentcolorc = 11;     noprefc = 0;  checkValuesC();};
radiobutton12c.onClick = function(){currentcolorc = 12;     noprefc = 0;  checkValuesC();};
radiobutton13c.onClick = function(){currentcolorc = 13;     noprefc = 0;  checkValuesC();};
radiobutton14c.onClick = function(){currentcolorc = 14;     noprefc = 0;  checkValuesC();};
radiobutton15c.onClick = function(){currentcolorc = 15;     noprefc = 0;  checkValuesC();};
radiobutton16c.onClick = function(){currentcolorc = 16;     noprefc = 0;  checkValuesC();};

function checkValuesC(){
//    if(currentcolorc ==  0){radiobutton1c.value = true;}else{radiobutton1c.value = false;}
    if(currentcolorc ==  1){radiobutton1c.value = true;}else{radiobutton1c.value = false;}
    if(currentcolorc ==  2){radiobutton2c.value = true;}else{radiobutton2c.value = false;}
    if(currentcolorc ==  3){radiobutton3c.value = true;}else{radiobutton3c.value = false;}
    if(currentcolorc ==  4){radiobutton4c.value = true;}else{radiobutton4c.value = false;}
    if(currentcolorc ==  5){radiobutton5c.value = true;}else{radiobutton5c.value = false;}
    if(currentcolorc ==  6){radiobutton6c.value = true;}else{radiobutton6c.value = false;}
    if(currentcolorc ==  7){radiobutton7c.value = true;}else{radiobutton7c.value = false;}
    if(currentcolorc ==  8){radiobutton8c.value = true;}else{radiobutton8c.value = false;}
    if(currentcolorc ==  9){radiobutton9c.value = true;}else{radiobutton9c.value = false;}
    if(currentcolorc == 10){radiobutton10c.value = true;}else{radiobutton10c.value = false;}
    if(currentcolorc == 11){radiobutton11c.value = true;}else{radiobutton11c.value = false;}
    if(currentcolorc == 12){radiobutton12c.value = true;}else{radiobutton12c.value = false;}
    if(currentcolorc == 13){radiobutton13c.value = true;}else{radiobutton13c.value = false;}
    if(currentcolorc == 14){radiobutton14c.value = true;}else{radiobutton14c.value = false;}
    if(currentcolorc == 15){radiobutton15c.value = true;}else{radiobutton15c.value = false;}
    if(currentcolorc == 16){radiobutton16c.value = true;}else{radiobutton16c.value = false;}
    selectedColors();
}
checkValuesC();

                // Row 5
                // ======
                var row5 = dialog.add("group", undefined, {name: "group1"}); 
                    row5.orientation = "row"; 
                    row5.alignment = ["right","center"]; 
                    row5.spacing = 10; 
                    row5.margins = 0; 

    // regular buttons 
    // ======
                                var button3 = row5.add("button", undefined, undefined, {name: "button3"}); 
                                    button3.text = "Delete Prefs"; 
                                    button3.onClick = function() {
                                        app.preferences.deletePref("keyframe buttons", "keyframe button # 1")
                                        app.preferences.deletePref("keyframe buttons", "keyframe button # 2")
                                        app.preferences.deletePref("keyframe buttons", "keyframe button # 3")
                                        app.preferences.deletePref("keyframe buttons", "keyframe button # 4")
                                        $.writeln("preferences color buttons deleted");
                                        dialog.close();
                                    };
                                var button1 = row5.add("button", undefined, undefined, {name: "button1"}); 
                                    button1.text = "Choose colors"; 
                                    button1.onClick = function() {
                                        
                                        if(currentcolor ==  1){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 1); }
                                        if(currentcolor ==  2){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 2); }
                                        if(currentcolor ==  3){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 3); }
                                        if(currentcolor ==  4){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 4); }
                                        if(currentcolor ==  5){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 5); }
                                        if(currentcolor ==  6){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 6); }
                                        if(currentcolor ==  7){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 7); }
                                        if(currentcolor ==  8){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 8); }
                                        if(currentcolor ==  9){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 9); }
                                        if(currentcolor ==  10){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 10); }
                                        if(currentcolor ==  11){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 11); }
                                        if(currentcolor ==  12){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 12); }
                                        if(currentcolor ==  13){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 13); }
                                        if(currentcolor ==  14){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 14); }
                                        if(currentcolor ==  15){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 15); }
                                        if(currentcolor ==  16){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 1", 16); }
                                        //A
                                        if(currentcolora ==  1){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 1); }
                                        if(currentcolora ==  2){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 2); }
                                        if(currentcolora ==  3){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 3); }
                                        if(currentcolora ==  4){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 4); }
                                        if(currentcolora ==  5){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 5); }
                                        if(currentcolora ==  6){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 6); }
                                        if(currentcolora ==  7){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 7); }
                                        if(currentcolora ==  8){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 8); }
                                        if(currentcolora ==  9){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 9); }
                                        if(currentcolora ==  10){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 10); }
                                        if(currentcolora ==  11){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 11); }
                                        if(currentcolora ==  12){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 12); }
                                        if(currentcolora ==  13){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 13); }
                                        if(currentcolora ==  14){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 14); }
                                        if(currentcolora ==  15){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 15); }
                                        if(currentcolora ==  16){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 2", 16); }
                                        //B
                                        if(currentcolorb ==  1){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 1); }
                                        if(currentcolorb ==  2){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 2); }
                                        if(currentcolorb ==  3){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 3); }
                                        if(currentcolorb ==  4){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 4); }
                                        if(currentcolorb ==  5){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 5); }
                                        if(currentcolorb ==  6){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 6); }
                                        if(currentcolorb ==  7){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 7); }
                                        if(currentcolorb ==  8){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 8); }
                                        if(currentcolorb ==  9){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 9); }
                                        if(currentcolorb ==  10){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 10); }
                                        if(currentcolorb ==  11){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 11); }
                                        if(currentcolorb ==  12){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 12); }
                                        if(currentcolorb ==  13){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 13); }
                                        if(currentcolorb ==  14){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 14); }
                                        if(currentcolorb ==  15){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 15); }
                                        if(currentcolorb ==  16){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 3", 16); }
                                        //C
                                        if(currentcolorc ==  1){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 1); }
                                        if(currentcolorc ==  2){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 2); }
                                        if(currentcolorc ==  3){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 3); }
                                        if(currentcolorc ==  4){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 4); }
                                        if(currentcolorc ==  5){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 5); }
                                        if(currentcolorc ==  6){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 6); }
                                        if(currentcolorc ==  7){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 7); }
                                        if(currentcolorc ==  8){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 8); }
                                        if(currentcolorc ==  9){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 9); }
                                        if(currentcolorc ==  10){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 10); }
                                        if(currentcolorc ==  11){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 11); }
                                        if(currentcolorc ==  12){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 12); }
                                        if(currentcolorc ==  13){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 13); }
                                        if(currentcolorc ==  14){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 14); }
                                        if(currentcolorc ==  15){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 15); }
                                        if(currentcolorc ==  16){ app.preferences.savePrefAsFloat("keyframe buttons", "keyframe button # 4", 16); }
                                        
                                        $.writeln("Color chosen");
                                        dialog.close();
                                    };
                                    
                                var button2 = row5.add("button", undefined, undefined, {name: "button2"}); 
                                    button2.text = "Cancel"; 
                                    button2.onClick = function() {
                                        $.writeln("Cancel pressed");
                                        dialog.close();
                                    };


                dialog.show();

    }

colorDialog();